package net.wanji.web.service;

import net.wanji.common.framework.rest.JsonViewObject;
import net.wanji.databus.bo.CrossIdBO;
import net.wanji.web.dto.CrossIdAndPhaseIdsDTO;
import net.wanji.web.dto.CrossIdAndTimeDTO;
import net.wanji.web.dto.ScheduleIdDTO;
import net.wanji.web.dto.SchemeIdDTO;
import net.wanji.web.po.RingPhasePO;
import net.wanji.web.vo.PhaseListByTimeVO;

/**
 * @author Kent HAN
 * @date 2022/11/3 16:14
 */
public interface PlanSendService {
    JsonViewObject scheduleSend(ScheduleIdDTO scheduleIdDTO);

    JsonViewObject schemeSend(SchemeIdDTO schemeIdDTO);

    JsonViewObject nextStep(CrossIdBO crossIdBO);

    JsonViewObject lockPhase(CrossIdAndPhaseIdsDTO crossIdAndPhaseIdsDTO);

    JsonViewObject allRedControl(CrossIdBO crossIdBO);

    JsonViewObject yellowLightControl(CrossIdBO crossIdBO);

    JsonViewObject restore(CrossIdAndPhaseIdsDTO crossIdAndPhaseIdsDTO);

    JsonViewObject syncScheme(CrossIdBO crossIdBO) throws Exception;

    PhaseListByTimeVO phaseListByTime(CrossIdAndTimeDTO crossIdAndTimeDTO);

    RingPhasePO phaseListByTimeSingleRing(CrossIdAndTimeDTO crossIdAndTimeDTO);

    /**
     * 下发数据到utc数据库
     *
     * @param crossId
     * @return
     */
    JsonViewObject saveToUtc(String crossId) throws Exception;
}
